<script setup lang="ts">
    import { useMsal } from '@/plugins/msal/useMsal'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import { Ref, ref } from 'vue'
    import SContentContainer from '@/components/layout/SContentContainer.vue'
    import { InterventionServiceOfferApi } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOfferApi'
    import SFooter from '@/components/layout/SFooter.vue'
    import SInterventionServiceOfferForm from '@/shared/administration/components/interventionServiceOffer/SInterventionServiceOfferForm.vue'
    import SContextualNavbar from '@/shared/navbar/components/SContextualNavbar.vue'
    import { useRouter, useRoute } from 'vue-router'
    import { interventionServiceOfferMapper } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOfferMapper'
    import { InterventionServiceOffer } from '@/interventionServiceOffer/entities/interventionServiceOffer/InterventionServiceOffer'
    import { useBreadcrumb } from '@/shared/routing/composables/breadCrumb'
    import { DeepPartial, isDefined } from '@/shared/helpers/types'
    import { z } from 'zod'

    const msal = useMsal()
    const interventionServiceOfferApi = new InterventionServiceOfferApi(msal)

    const router = useRouter()
    const route = useRoute()
    const { getParentRoute } = useBreadcrumb()

    const existingInterventionServiceOfferIdToDuplicate = z
        .string()
        .optional()
        .parse(route.query.existingInterventionServiceOfferIdToDuplicate)
    const interventionServiceOffer: Ref<DeepPartial<InterventionServiceOffer>> =
        ref({
            link: 'intervention-service-offer/index',
            gestionRecompletementActif: false,
            gestionDatesSouhaiteesPourDemandeInterventionActif: false,
            gestionDatesPourInterventionActif: false,
            configurationFormulaireActivite: {
                dateDeDebut: 'automatique',
                heureParDefautEnMinute: 8 * 60,
            },
            availableEquipementsIds: [],
        })

    if (isDefined(existingInterventionServiceOfferIdToDuplicate)) {
        interventionServiceOfferApi
            .get(existingInterventionServiceOfferIdToDuplicate)
            .then((fetchedInterventionServiceOffer) => {
                interventionServiceOffer.value = fetchedInterventionServiceOffer
            })
            .catch((error) => {
                emitSnackBar((<Error>error).message, 'error')
                router.push(getParentRoute())
            })
    }

    async function createInterventionServiceOffer() {
        try {
            await interventionServiceOfferApi.create(
                interventionServiceOfferMapper.toCreateDto(
                    interventionServiceOffer.value
                )
            )

            emitSnackBar(
                `Offre de service "${interventionServiceOffer.value.title}" créée`,
                'primary'
            )
            router.push(getParentRoute())
        } catch (error) {
            console.error(error)
            emitSnackBar((<Error>error).message, 'error')
            router.push(getParentRoute())
        }
    }
</script>

<template>
    <s-contextual-navbar
        page-title="Créer une offre de service intervention"
    ></s-contextual-navbar>
    <v-main>
        <s-content-container>
            <s-intervention-service-offer-form
                v-model="interventionServiceOffer"
                :loading="interventionServiceOfferApi.isProcessing.value"
                @submit.prevent="createInterventionServiceOffer()"
            >
            </s-intervention-service-offer-form>
        </s-content-container>
    </v-main>
    <s-footer />
</template>
